/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/****************************** Module Header ******************************\
*
* Module Name: PMP.H
*
* OS/2 Presentation Manager top level include file.
*
*
*
* ===========================================================================
*
* The following symbols are used in this file for conditional sections.
*
*   #define:                To include:
*
*   INCL_PMP    -  ALL of OS/2 PRIVATE Presentation Manager
*   INCL_WINP   -  OS/2 PRIVATE Window Manager
*   INCL_SHLP   -  OS/2 PRIVATE Shell
*   INCL_DEVP   -  OS/2 PRIVATE Device Context
*   INCL_GPIP   -  OS/2 PRIVATE GPI
*   INCL_AVIOP  -  OS/2 PRIVATE Avio
*   INCL_SPLP   -  OS/2 PRIVATE Spooler
*   INCL_HELP   -  OS/2 PRIVATE Help
*   INCL_TKTP   -  OS/2 PRIVATE Toolkit
*
* ===========================================================================
*
* Comments at the end of each typedef line give the name tags used in
* the assembler include version of this file.
*
* The assembler include version of this file excludes lines between NOINC
* and INC comments.
*
#ifndef __IBMC__
   * The 32-bit version of this file (as placed into the IBMH directory)
   * excludes all non 32-bit material marked in this file as well
   * as any areas specifically marked with __IBMC__ conditional
   * sections - including this paragraph. The H2IBMH rexx command file
   * removes these sections.
#endif
\***************************************************************************/

/* NOINC */
#ifdef __IBMC__
   #pragma checkout( suspend )
      #ifndef __CHKHDR__
         #pragma checkout( suspend )
      #endif
   #pragma checkout( resume )
#endif
/* INC */

#define PMP_INCLUDED

#ifndef INCL_32         /* If neither INCL_32 or INCL_16 set already */
   #ifndef INCL_16      /* find out from compiler if 32-bit or not.  */
     #ifdef M_I386
        #define INCL_32 /* Compiling for 32-bit */
     #else
        #define INCL_16 /* Compiling for 16-bit */
     #endif
  #endif
#endif

/* if INCL_PMP defined then define all the symbols */
#ifdef INCL_PMP
    #define INCL_WINP
    #define INCL_SHLP
    #define INCL_DEVP
    #define INCL_GPIP
    #define INCL_AVIOP
    #define INCL_SPLP
    #define INCL_HELP
    #define INCL_TKTP
#endif /* INCL_PMP*/

#ifdef INCL_WINP
#include <pmwinp.h>    /* PRIVATE OS/2 Window Manager definitions */
#endif

#ifdef INCL_SHLP
#include <pmshlp.h>    /* PRIVATE OS/2 Shell definitions */
#endif

#ifdef INCL_DEVP
#include <pmdevp.h>    /* PRIVATE OS/2 Device Context definitions */
#endif

#ifdef INCL_GPIP
#include <pmgpip.h>    /* PRIVATE OS/2 GPI definitions */
#endif

#ifdef INCL_AVIOP
#include <pmaviop.h>   /* PRIVATE OS/2 AVIO definitions */
#endif

#ifdef INCL_SPLP
#include <pmsplp.h>    /* PRIVATE OS/2 Spooler definitions */
#endif

#if (defined(INCL_HELP) || defined(INCL_TKTP))
#include <pmtktp.h>    /* PRIVATE OS/2 Toolkit definitions */
#endif

/* NOINC */
#ifdef __IBMC__
   #pragma checkout( suspend )
      #ifndef __CHKHDR__
         #pragma checkout( resume )
      #endif
   #pragma checkout( resume )
#endif
/* INC */

/**************************** end of file **********************************/
