/**************************************************************************
 *
 * SOURCE FILE NAME = DDK_REF.CMD
 *
 * DESCRIPTIVE NAME = Create Objects on the desktop
 *
 * Copyright : COPYRIGHT IBM CORPORATION, 1993
 *             LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
 *             REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
 *             RESTRICTED MATERIALS OF IBM
 *
 * VERSION = V2.1
 *
 * DATE
 *
 * DESCRIPTION  This command creates Icons on the Desktop
 *
 * Functions
 *
 * CHANGE ACTIVITY =
 *                        Def#/
 *  DATE      FLAG        APAR#    CHANGE DESCRIPTION
 *  --------  ----------  -----    --------------------------------------
 *  08/01/93  @V2.1jagank xxxxx    Created  - Jagan Karuturi
 *
 ****************************************************************************/

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

parse source . . source_path .
drive = filespec( 'Drive', source_path )
path  = filespec( 'Path', source_path )
filename = filespec( 'Name', source_path )

classname = 'WPFolder'
title= 'DDK References^on DDK CD-ROM'
location='<DDKI_FOLDER>'
setup = 'OBJECTID=<DDKREF_FOLDER>;' ||,
        'ICONFILE='Drive||path'ddkref.ico;'||,
        'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')
result=SysSetObjectData('<DDKREF_FOLDER>', 'ICONVIEW=FLOWED')

/* Input/Output Device Driver Reference */
classname = 'WPProgram'
title     = 'I/O Device^Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References1>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\IN_OUT.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\IN_OUT.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')

/* Display Device Driver Reference */
classname = 'WPProgram'
title     = 'Display Device^Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References2>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\DISPLAY.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\DISPDRVR.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* Printer Device Driver Reference */
classname = 'WPProgram'
title     = 'Printer Device^Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References3>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\PRINTER.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\PRNTRDRV.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* Storage Device Driver Reference */
classname = 'WPProgram'
title     = 'Storage Device^Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References4>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\STORAGE.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\STORAGED.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* Pen for OS/2 Device Driver Reference */
classname = 'WPProgram'
title     = 'Pen for OS/2^Device Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References5>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\PENOS2.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\PENDRVRE.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* MMPM/2 Device Driver Reference */
classname = 'WPProgram'
title     = 'MMPM/2* Device^Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References6>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\MMPM2.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\MMPMDRVR.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* Virtual Device Driver Reference */
classname = 'WPProgram'
title     = 'Virtual Device^Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References7>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\VDDREF.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\VIRDRVRE.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* Physical Device Driver Reference */
classname = 'WPProgram'
title     = 'Physical Device^Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References8>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\PDDREF.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\PHYSDRVR.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* Presentation Device Driver Reference */
classname = 'WPProgram'
title     = 'Presentation^Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References9>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\PDRREF.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\PRESDRVR.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* Writing OS/2 DD in C */
classname = 'WPProgram'
title     = "Writing OS/2 2.1^Device Drivers in C"
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References10>;'||,
            'EXENAME=VIEW.EXE;'||,
            'PARAMETERS='Drive'\ddkx86\book\SMBOOK.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\SMBOOK.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* PowerPc Reference */
classname = 'WPProgram'
title     = 'PowerPC Reference^Platform Specification V1.0'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References11>;'||,
            'EXENAME=view.exe;'||,
            'PARAMETERS='Drive'\ddkx86\book\SRPBASE.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\SRPBASE.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/* SMP Reference */
classname = 'WPProgram'
title     = 'OS/2 for SMP V2.11 Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References12>;'||,
            'EXENAME=view.exe;'||,
            'PARAMETERS='Drive'\ddkx86\book\Smp.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\Smp.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')

/* OEM COMPATABILITY LIST */
classname = 'WPProgram'
title     = 'OS/2 Harware^Compatability List'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References13>;'||,
            'EXENAME=view.exe;'||,
            'PARAMETERS='Drive'\ddkx86\book\oemlist.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\hcl.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')

/* Gradd Reference */
classname = 'WPProgram'
title     = 'Graphics Adapter Device^Driver Reference'
location  = '<DDKREF_FOLDER>'
setup     = 'OBJECTID=<References14>;'||,
            'EXENAME=view.exe;'||,
            'PARAMETERS='Drive'\ddkx86\book\gradd.INF;'||,
            'ICONFILE='Drive'\ddkx86\book\gradd.ICO;'||,
            'PROGTYPE=PM;'

result=SysCreateObject(classname,title,location,setup, 'R')


/*say 'Created <DDK References> folder on to your desktop.'
say
say 'Double click on the <DDK References> folder and now'
say 'you can view the reference books'
*/
exit

